program ScreenMatrix;

{$mode objfpc}{$H+}

{ QEMU VersatilePB Application                                                 }
{  Add your program code below, add additional units to the "uses" section if  }
{  required and create new units by selecting File, New Unit from the menu.    }
{                                                                              }
{  To compile your program select Run, Compile (or Run, Build) from the menu.  }

uses
  QEMUVersatilePB,
  GlobalConfig,
  GlobalConst,
  GlobalTypes,
  Platform,
  Threads,
  SysUtils,
  Classes,
  Console,
  Ultibo
  { Add additional units here };


const
  Matrix_Breite = 110;
  Matrix_Hoehe  = 40;


type

  T_BWS_Zeichen = record
                    Zeichen : Char;
                    F_COLOR, B_COLOR : LongWord;
                  end;

  T_BWS_Matrix = Array [1..Matrix_Breite,1..Matrix_Hoehe] of T_BWS_Zeichen;

var

 zaehler_x, zaehler_y : LongWord;
 Handle1:TWindowHandle;


 B_Zeichen : Byte;

 F_Farbe, H_Farbe : LongWord;

 BWS_Matrix : T_BWS_Matrix;



 procedure BWS_Matrix_fuellen;
 begin

   for Zaehler_y:=1 to Matrix_Hoehe do begin

     for Zaehler_x:=1 to Matrix_Breite do begin

       BWS_Matrix[Zaehler_x,Zaehler_y].Zeichen:=Char(B_Zeichen);
       Inc(B_Zeichen);
       if B_Zeichen=$80 then begin
         B_Zeichen:=$20;
       end;
       BWS_Matrix[Zaehler_x,Zaehler_y].F_COLOR:=F_Farbe;
       F_Farbe:=F_Farbe+2;
       BWS_Matrix[Zaehler_x,Zaehler_y].B_COLOR:=H_Farbe;
       H_Farbe:=H_Farbe-1;

     end;

   end;

 end; { procedure BWS_Matrix_fuellen }




  procedure BWS_Matrix_anzeigen;
  begin

    for Zaehler_y:=1 to Matrix_Hoehe do begin

      for Zaehler_x:=1 to Matrix_Breite do begin

        ConsoleWindowWriteLnEx(Handle1,
          BWS_Matrix[Zaehler_x,Zaehler_y].Zeichen,
          Zaehler_x,Zaehler_y,
          BWS_Matrix[Zaehler_x,Zaehler_y].F_COLOR,
          BWS_Matrix[Zaehler_x,Zaehler_y].B_COLOR);

      end;

    end;

  end; { procedure BWS_Matrix_anzeigen }



begin

  Handle1:=ConsoleWindowCreate(ConsoleDeviceGetDefault,CONSOLE_POSITION_FULL,True);

  B_Zeichen:=$20;
  F_Farbe:=0;
  H_Farbe:=0;

  while true do begin

    BWS_Matrix_fuellen;
    BWS_Matrix_anzeigen;

    sleep(2000);

  end;


 {We're not doing a loop this time so we better halt this thread before it exits}
 ThreadHalt(0);
end.

